"use strict";
{
    self.C3.Plugins.FedericoCalchear_Set.Cnds = {
        Has(value)
        {
            return this._set.has(value);
        },

        Foreach()
        {
            // Get necessary references
            const runtime = this._runtime;
            const eventSheetManager = runtime.GetEventSheetManager();
            const currentEvent = runtime.GetCurrentEvent();
            const solModifiers = currentEvent.GetSolModifiers();
            const eventStack = runtime.GetEventStack();

            // Get current stack frame and push new one
            const oldFrame = eventStack.GetCurrentStackFrame();
            const newFrame = eventStack.Push(currentEvent);

            for (const value of this._set)
            {

                this._curValue = value;

                // Push a copy of the current SOL
                eventSheetManager.PushCopySol(solModifiers);

                // Retrigger the current event, running a single loop iteration
                currentEvent.Retrigger(oldFrame, newFrame);

                // Pop the current SOL
                eventSheetManager.PopSol(solModifiers);
            }

            // Pop the event stack frame
            eventStack.Pop();

            // Return false since event already executed
            return false;
        }
    };
}